<template>
  <div>
    <div class="search">
      <img class="search-img" src="@/assets/images/cocktail.jpg" />
      <input
        class="search-input"
        placeholder="Would you like a cocktail ?"
        v-model="inputSearch"
        @keyup.enter="search"
        type="text"
      />
    </div>
    <div v-if="isEmptyRequest" class="wrapper">
      <p class="empty">No cocktail found !</p>
    </div>
    <div v-else class="wrapper">
      <div class="box" v-for="(c, index) in cocktails" :key="index">
        <CardCocktail :cocktail="c" @sending-cocktail="receivedCocktail"></CardCocktail>
      </div>
    </div>
  </div>
</template>

<script>
import CardCocktail from '../components/CardCocktail/CardCocktail.vue'
import axios from "axios";
import { Cocktail } from "@/assets/js/Cocktails.js";

export default {
  name: "Home",
  components: {
    CardCocktail,
  },
  data() {
    return {
      cocktails: [],
      inputSearch: "",
      isEmptyRequest: false,
    };
  },
  mounted() {
    this.getAll();
  },
  methods: {
    search() {
      let link = `https://www.thecocktaildb.com/api/json/v1/1/search.php?s=${this.inputSearch}`;
      this.getByName(link);
    },
    receivedCocktail(cocktail){
      this.$emit('sending-cocktail2', cocktail)
    },
    getAll() {
      axios
        .get(`https://www.thecocktaildb.com/api/json/v1/1/search.php?s=${this.inputSearch}`)
        .then((res) => {
          let data = [];
          data.push(res.data.drinks);
          this.convertDataToCocktail(data[0]);
        })
        .catch((err) => {
          console.err(err);
        });
    },
    convertDataToCocktail(data) {
      this.cocktails = new Array();
      for (let i = 0; i < data.length; i++) {
        let id = data[i].idDrink;
        let name = data[i].strDrink;
        let glassName = data[i].strGlass;
        let category = data[i].strCategory;
        let alcoholic = data[i].strAlcoholic;
        let image = data[i].strDrinkThumb;
        this.cocktails.push(
          new Cocktail(
            id,
            name,
            glassName,
            category,
            alcoholic,
            image,
          )
        );
      }
      this.cocktails.sort(this.sort);
    },
    sort(a, b) {
      if (a.name < b.name) return -1;
      if (a.name > b.name) return 1;
      return 0;
    },
    getByName(link) {
      axios
        .get(link)
        .then((res) => {
          let data = [];
          data.push(res.data.drinks);
          if (data[0] == null) this.isEmptyRequest = true;
          else {
            this.convertDataToCocktail(data[0]);
            this.isEmptyRequest = false;
          }
        })
        .catch((err) => {
          console.err(err);
        });
    },
  },
};
</script>

<style lang="scss">
@import "../assets/css/colors.scss";

.wrapper {
  position: flex;
  flex-wrap: wrap;
  margin: 2.5rem;
}

.empty {
  padding: 3rem;
  font-size: 3rem;
  font-weight: 600;
  font-style: oblique 10deg;
}

.search {
  position: relative;
  width: 100%;
  height: 25rem;
  box-shadow: 0 0 10px black;
}
.search-img {
  width: 100%;
  height: 25rem;
  object-fit: cover;
  object-position: 50% 52%;
  cursor: pointer;
}

.search-input {
  position: absolute;
  top: 60%;
  left: 50%;
  transform: translate(-50%, -50%);
  font-size: 18px;
  font-weight: bold;
  opacity: 0.3;
}

input[type="text"] {
  width: 50%;
  padding: 20px;
  border-width: 0px;
  text-align: center;
  color: $dark;
  background-color: $ligth;
  border-radius: 25px;
  box-shadow: 0 0 4px $text;
  line-height: 24px;
  font-size: 1.5rem;
  font-weight: bold;
  opacity: 0.85;
}
input:hover {
  outline: none;
}
input:focus {
  outline: none;
}
input::placeholder {
  color: $dark;
  font-size: 1.3em;
  font-weight: 600;
  opacity: 0.2;
}

.box {
  padding: 1rem;
  display: inline-flex;
  font-size: 150%;
}
</style>